# Change Log
All notable changes to `cspyce` will be documented here

The format is based on [Keep a Changelog](http://keepachangelog.com/)
and this project tries to adhere to [Semantic Versioning](http://semver.org/).

## [2.3.0] - 2024-06-18
Recompiled with NumPy 2.0.0, which supports both NumPy 1.x and 2.x. 
Python 3.8 no longer supported!

## [2.2.6] - 2024-05-14
Fixed problems with compiling on MacOS. Added contributing guide and code of 
conduct. Other minor cosmetic changes.

## [2.2.5] - 2024-02-05
Fix problem with too many boddefs.

## [2.2.4] - 2024-01-11
Change functions that return SpiceCells to allow an optional final argument
that is a SpiceCell to populate or an integer giving the size of the returned
SpiceCell (issue #154).
Fix a bug when zero-length arrays being passed to vectorized functions (issue #155).

## [2.2.3] - 2023-12-22
Fix a bug with `chbder` (issue #150).
Fix a problem with Windows where a compiler upgrade seems to have broken Windows
tests. We now use the NAIF pre-built library for Windows (issue #151).

## [2.2.2] - 2023-10-24
Repo renamed from SETI/pds-cspyce to SETI/rms-cspyce.

## [2.2.1] - 2023-10-18
Cosmetic changes to README.md.

## [2.2.0] - 2023-10-17
Support Python 3.12. 
Complete testing of all scalar functions.
Significant internal cleanup including fixing memory leaks.
Fix bugs with `dskgd`, `dskmi2`, `dskv02`, `ekacld`, `ekgd`, `ekifld`, 
`ekrcei`, `ekssum`, `frmchg`, `gcpool`, `gfocce`, `gfvent`, `lparse`, `lparsm`,
`matchi`, `matchw`, `prompt`, `refchg` and many others.
Allow all functions that expect a filename/path argument to accept a string, 
byte string, or `pathlib.Path` object. 
Implement SpiceCell data type.
Implement Plane and Ellipse data types.
Add IDE-detectable docstrings to all functions.
For full details see the top-level `README.md` and the docstrings for each
function.

## [2.1.1] - 2023-05-23
Fix various memory corruption issues that caused crashing under MacOS.
Fix implementation issues with `dafgda`, `dafus`, `dasrdc`, `dp2hx`,
and `dskd02`.

## [2.1.0] - 2023-05-04
Stable release using new release process. Remove all Python 2 support.
Add `cspyce.__version__` attribute. Fix bug with converting longlong to float
on Windows. Fix bug in `ckfxfm` where it was calling the wrong underlying
CSPICE function.

## [2.0.10 thru 2.0.11] - 2023-05-03
Convert LICENSE.txt to LICENSE.md. Improvements to release process and
documentation. Fix bug in `ckw01` and failing typemap tests.

## [2.0.9] - 2023-04-19
Fix minor bug in aliases, fix lmpool, fix problems with array support.
Add LICENSE.txt.

## [2.0.6 thru 2.0.8] - 2022-11-03
Improvements to release process.

## [2.0.5] - 2022-10-13
Fix crashes in aliases, improve docstrings, fix memory allocation errors.
Reorganize and add test cases.

## [2.0.4] - 2022-08-12
Fix crash in aliases, fix to work with Python 2.

## [2.0.3] - 2022-04-14
Major internal reorganization.

## [2.0.2] - 2022-03-21
Download the appropriate version of the CSPICE sources depending on
the architecture.

## [2.0.1] - 2022-03-21
Minor bug fixes.

## [2.0.0] - 2022-03-17
Internal rearrangement to support both Python 2 and Python 3 and also allow
installation with `pip`.
